## Typing stubs for tensorflow

This is a [PEP 561](https://peps.python.org/pep-0561/)
type stub package for the [`tensorflow`](https://github.com/tensorflow/tensorflow) package.
It can be used by type-checking tools like
[mypy](https://github.com/python/mypy/),
[pyright](https://github.com/microsoft/pyright),
[pytype](https://github.com/google/pytype/),
[Pyre](https://pyre-check.org/),
PyCharm, etc. to check code that uses `tensorflow`. This version of
`types-tensorflow` aims to provide accurate annotations for
`tensorflow~=2.18.0`.

Partially generated using [mypy-protobuf==3.6.0](https://github.com/nipunn1313/mypy-protobuf/tree/v3.6.0) and libprotoc 27.2 on `tensorflow==2.18.0`.

This stub package is marked as [partial](https://peps.python.org/pep-0561/#partial-stub-packages).
If you find that annotations are missing, feel free to contribute and help complete them.


This package is part of the [typeshed project](https://github.com/python/typeshed).
All fixes for types and metadata should be contributed there.
See [the README](https://github.com/python/typeshed/blob/main/README.md)
for more details. The source for this package can be found in the
[`stubs/tensorflow`](https://github.com/python/typeshed/tree/main/stubs/tensorflow)
directory.

This package was tested with
mypy 1.15.0,
pyright 1.1.389,
and pytype 2024.10.11.
It was generated from typeshed commit
[`e6165eadd680f45b00e37ba9342b5073bc884132`](https://github.com/python/typeshed/commit/e6165eadd680f45b00e37ba9342b5073bc884132).